﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Imports System.Collections.ObjectModel
Public Class MyEditOverlay
   Inherits EditInteractiveOverlay
   Private moEditFeature As Feature
   Public Property EditLayer As MyShapefile
   Public Property SelectionLayer As InMemoryFeatureLayer
   Public Property Map As WinformsMap
   Private moEditFeatures As New Collection(Of Feature)

   Protected Overrides Function MouseUpCore(ByVal interactionArguments As ThinkGeo.MapSuite.DesktopEdition.InteractionArguments) As ThinkGeo.MapSuite.DesktopEdition.InteractiveResult
      If moEditFeature IsNot Nothing Then
         EditLayer.BeginTransaction()
         Dim oFeature As Feature = EditLayer.QueryTools.GetFeatureById(moEditFeature.Id, ReturningColumnsType.AllColumns)
         moEditFeatures.Add(oFeature)

         moEditFeature.Tag = EditLayer

         '***** Edit the feature
         With EditLayer.EditTools
            .Update(moEditFeature)
         End With

         Map.Refresh()
         moEditFeature = Nothing
      End If

      Return MyBase.MouseUpCore(interactionArguments)
   End Function
   Protected Overrides Sub OnVertexMoved(ByVal e As ThinkGeo.MapSuite.DesktopEdition.VertexMovedEditInteractiveOverlayEventArgs)
      MyBase.OnVertexMoved(e)
      moEditFeature = e.AffectedVertexFeature
   End Sub
   Protected Overrides Sub DrawCore(canvas As ThinkGeo.MapSuite.Core.GeoCanvas)
      MyBase.DrawCore(canvas)
   End Sub
End Class
